<template>
  <div class="container">
    <h2>New Special</h2>
    <b-form-group
      label="Self inflicted?"
      class="container">
      <b-form-radio-group v-model="target_self">
        <b-form-radio
          :class="target_self ? 'seltar' : ''"
          :value="true">
          true
        </b-form-radio>
        <b-form-radio
          :class="!target_self ? 'seltar' : ''"
          :value="false">
          false
        </b-form-radio>
      </b-form-radio-group>
    </b-form-group>
    <b-form-input
      v-model="power"
      placeholder="power"
      type="number">
    </b-form-input>
    <b-form-input
      v-model="stat"
      placeholder="stat"
      type="number">
    </b-form-input>
    <div class="buttons">
      <b-button-group>
        <b-button 
          variant="success"
          @click="submit"
          :disabled="!valid">Submit</b-button>
        <b-button 
          variant="danger"
          @click="cancel">Cancel</b-button>
      </b-button-group>
    </div>
    <div>
      <b-alert
        :show="error != ''"
        variant="danger">
        {{ error }}
      </b-alert>
    </div>
  </div>
</template>

<script>
export default {
  data() {
    return {
      target_self: false,
      power: '',
      stat: '',
      error: ''
    };
  },
  computed: {
    valid() {
      return this.power * this.stat > 0
    }
  },
  methods: {
    submit() {
      let data = {
        special: {
          power: this.power,
          target_self: this.target_self,
          stat: this.stat
        }
      },
      ins = this;

      this.error = '';

      this.$axios({
        method: 'post',
        url: 'http://localhost:3000/specials',
        data: data
      })
        .then(res => {
          ins.$router.go();
        })
        .catch(err => {
          ins.error = 'Ocorreu um erro... :(';
        })
    },
    cancel() {
      this.name = '';
      this.cost = '';
    }
  }
}
</script>

<style>
.container {
  max-width: 35vw;
  border: 0.2rem solid lightgray;
  border-radius: 10px;
  padding: 1rem;
}

.buttons {
  display: flex;
  justify-content: center;
}

.target {
  display: flex;
  flex-direction: column;
}

.seltar {
  font-weight: bold;
}
</style>
